<template>
    <div>
        <h2>Inscription</h2>
        <div>
            <form
                class="uk-form-horizontal uk-margin-large uk-margin-medium-bottom"
            >
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Email</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="email"
                        v-model="email"
                    />
                </div>
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Mot de passe</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="password"
                        style="-webkit-text-security: circle"
                        v-model="password"
                    />
                </div>
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Confirmer le mot de passe</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        style="-webkit-text-security: circle"
                        type="password"
                        v-model="passwordConfirmed"
                    />
                </div>
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Nom</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="text"
                        v-model="nom"
                    />
                </div>
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Prenom</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="text"
                        v-model="prenom"
                    />
                </div>
                <div class="uk-margin">
                    <label class="uk-form-label" for="form-horizontal-text"
                        >Pseudo</label
                    >
                    <input
                        class="uk-input uk-form-width-medium"
                        type="text"
                        v-model="pseudo"
                    />
                </div>
            </form>
        </div>
        <div class="uk-text-danger" v-if="messageErreur">
            {{ messageErreur }}
        </div>
        <div class="uk-margin-remove-bottom">
            <button
                class="uk-button uk-button-default button-connexion uk-align-center"
                @click="envoiInscription()"
            >
                S'inscrire
            </button>

            <BoutonGoogle/>
        </div>
    </div>
</template>

<script lang="ts">
import Axios from '@/auth/axiosAuth';
import UIkit from 'uikit';
import Utilisateur from '@/classes/Utilisateur';
import BoutonGoogle from './BoutonGoogle.vue';

export default {
    components: {
        BoutonGoogle
    },
    data() {
        return {
            email: '',
            password: '',
            passwordConfirmed: '',
            nom: '',
            prenom: '',
            pseudo: '',
            messageErreur: '',
        };
    },
    methods: {
        envoiInscription(): void {
            this.messageErreur = '';
            if (
                this.email === '' ||
                this.password === '' ||
                this.nom === '' ||
                this.prenom === '' ||
                this.pseudo === ''
            ) {
                this.messageErreur = 'Merci de renseigner tous les champs';
            } else if (!this.validateEmail(this.email)) {
                this.messageErreur = "Le format de l'email est incorrect";
            } else if (this.password != this.passwordConfirmed) {
                this.messageErreur =
                    'Les mots de passes ne sont pas identiques';
            } else {
                const formData = new FormData();
                formData.append('email', this.email);
                formData.append('password', btoa(this.password));
                formData.append('nom', this.nom);
                formData.append('prenom', this.prenom);
                formData.append('pseudo', this.pseudo);
                Axios.postUnLogged(
                    'auth/subscribe/',
                    (next) => {
                        this.email = '';
                        this.password = '';
                        this.passwordConfirmed = '';
                        this.nom = '';
                        this.prenom = '';
                        this.pseudo = '';
                        this.messageErreur = '';
                        UIkit.modal('#auth-modal').hide();
                        const token = next.data.accessToken;
                        const user = new Utilisateur();
                        user.mapperJson(next.data.user);
                        this.$auth.login(user, token, true);
                    },
                    formData,
                    (error) => {
                        if (error.response.status === 409) {
                            const message = error.response.data.message;
                            if (message === 'email') {
                                this.messageErreur = "L'email est déjà utilisé";
                            } else if (message === 'pseudo') {
                                this.messageErreur =
                                    'Le pseudo est déjà utilisé';
                            }
                        }
                    },
                );
            }
        },

        validateEmail(email: string): boolean {
            return (
                email
                    .toLowerCase()
                    .match(
                        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
                    ) != undefined
            );
        },
    },
};
</script>
<style scoped>
.button-connexion {
    width: 60%;
    margin-bottom: 8px;
    margin-top: 0px !important;
}
</style>